/* report text builder
 * (c) 2010 Maoyam Tokyo, Japan (maoyam@mail.goo.ne.jp)
 */
package report;

import java.util.List;

/** eLXgҏWCAEg\z邽߂́uubNvm[hB
 * R[hƃTuEubNċAIɕێB
 * em[h́AubNCAEgɂȂB
 */
public class Block extends Node {
	/** pbP[WE[U`ubN\nh */
	private BlockBuilder	builder = null;
	/** pbP[WE[U`ubN\nh̃Qb^ */
	BlockBuilder getBuilder() {	return	this.builder;	}

	/** em[hƂȂ郌CAEgw肵ăubN𐶐RXgN^B
	 * @param ancestor em[hƂȂ郌CAEgnB
	 * @param builder pbP[WE[U`ubN\nhnB
	 */
	public Block(Layout	ancestor, BlockBuilder	builder) {
		super(ancestor);
		this.builder	= builder;
	}
	/** em[hƂȂubNw肵ăubN𐶐RXgN^B
	 * @param  ancestor em[hƂȂubNnB
	 * @param builder pbP[WE[U`ubN\nhnB
	 */
	public Block(Block	ancestor, BlockBuilder	builder) {
		super(ancestor);
		this.builder	= builder;
	}
	/** pbP[WE[U`ubN\nhw肵ăubN𐶐RXgN^B
	 * em[h͕sƂȂB
	 * @param builder pbP[WE[U`ubN\nhnB
	 */
	public Block(BlockBuilder	builder) {
		super();
		this.builder	= builder;
	}
	/** em[hs̃ubN𐶐RXgN^B<BR>
	 * Node#merge() ɓnăCAEg̔Cӂ̉ӏɍޕc[邽߂Ɏgp邱Ƃz肵ĂB<BR>
	 * ubN\nh݂͑ȂB
	 */
	public Block() {	this(null);	}

	/** m[hAubN̐em[h (CAEgubN) ł邱ƂmFB
	 * @param node mFm[hnB
	 * @return m[hubN̐em[hɎwł̂Ȃ true AłȂ false ԂB
	 */
	private boolean isValidAncestor(Node	node) {
		return	((node instanceof Layout || node instanceof Block)
				?	true:	false
				);
	}
	/** ̃ubNɎw肳Ăem[hACAEgubNł邱ƂmFB
	 * @return em[h true AłȂ false ԂB
	 */
	private boolean isValidAncestor() {
		return isValidAncestor(getAncestor());
	}

	/** ubN̎qm[hƂĐȂ̂ł邱ƂmFB
	 * @param child mFm[hnB
	 * @return ubN̎qm[hƂĐł true AłȂ false ԂB
	 */
	private boolean isValidChild(Node	child) {
		return	((child instanceof Block || child instanceof Record)
				?	true :	false
				);
	}

	/** qm[h̔zubNɒǉB
	 * @param children qm[h̔znB
	 * @return qm[hǉubNԂB
	 * @exception sȎqm[hnȂǂ̏ꍇ ReportException𓊂B
	 */
	public Block adda(Node children[]) throws ReportException {
		if (children != null) {
			for (int i = 0; i < children.length; ++i) {
				if (isValidChild(children[i]) != true) {
					throw (new ReportException("not acceptable child"
											+ "[" + i + "]"
											+ "={" + children[i] + "}"
											)
							);
				}
			}
		}
		return	(Block)super.adda(children);
	}

	/** ό̎qm[hubNɒǉB
	 * @param children ό̎qm[hnB
	 * @return qm[hǉubNԂB
	 * @exception sȎqm[hnȂǂ̏ꍇ ReportException𓊂B
	 */
	public Block add(Node... children) throws ReportException {
		return	adda(children);
	}

	/** qm[h̃XgubNɒǉB
	 * @param children qm[h̃XgnB
	 * @return qm[hǉubNԂB
	 * @exception sȎqm[hnȂǂ̏ꍇ ReportException𓊂B
	 */
	public Block add(List<? extends Node> children) throws ReportException {
		if (children != null) {
			int	i = 0;
			for (Node child : children) {
				if (isValidChild(child) != true) {
					throw (new ReportException("not acceptable child"
											+ "(" + i + ")"
											+ "={" + child + "}"
											)
							);
				}
			}
			super.add(children);
		}
		return	this;
	}

	/** ̃CAEgubN̎qm[hÃubNɈڂB
	 * @param another ̃CAEgubNnB
	 * @return ̃m[h̎qm[hڂ̃ubNԂB
	 * @exception sȃm[hnȂǂ̏ꍇ ReportException𓊂B
	 */
	public Block merge(Node	another) throws ReportException {
		if (another != null) {
			if (isValidAncestor(another) != true) {
				throw (new ReportException("cannot merge another node"
											+ "={" + another + "}"
											)
						);
			}
			add(another.getChildren());
		}
		return	this;
	}

	/** ̃ubNƎqm[h̐mFB
	 * @return łƊmFꂽ̃ubNԂB
	 * @exception ̃ubNłȂꍇ ReportException 𓊂B
	 */
	public Block verify() throws ReportException {
		super.verify();
		if (isValidAncestor() != true) {
			throw (new ReportException("invalid ancestor"
										+ "={" + getAncestor() + "}"
										)
					);
		}
		else {
			int	i = 0;
			for (Node child : getChildren()) {
				if ((isValidChild(child) != true)
				|| child.verify() != child)
				{	throw (new ReportException("invalid child(" + i + ")"
												+ "={" + child + "}"
												)
							);
				}
				++i;
			}
		}
		return	this;
	}
}
