/* report text builder
 * (c) 2010 Maoyam Tokyo, Japan (maoyam@mail.goo.ne.jp)
 */
package report;

import java.util.ArrayList;
import java.util.List;

/** ҏWf[^EZbgǂݏoҏWf[^L[[hŌf[^\ */
public class DataDictionary {
	/** report pbP[Wŗ\񂵂ĂL[[hێ鎫\ */
	private Keyword	assignedKeywords = null;
	/** ݂̃y[Wԍݒ肷B
	 * @param pageNo ݂̃y[WԍnB
	 * @return ύX܂̃y[WԍԂB
	 */
	String setCurrentPageNum(int	pageNo) {
		return	assignedKeywords.put(Keyword.CURRENT_PAGE_NUM
									, Integer.valueOf(pageNo).toString()
									);
	}
	/** y[Wݒ肷B
	 * @param totalPageNums x[nB
	 * @return ύXȎy[WԂB
	 */
	String setTotalPageNums(int	totalPageNums) {
		return	assignedKeywords.put(Keyword.TOTAL_PAGE_NUMS
								, Integer.valueOf(totalPageNums).toString()
								);
	}
	/** report pbP[W\񂵂ĂL[[hɑΉu𓾂B
	 * @param keyword pbP[W\񂵂ĂL[[hnB
	 * @return pbP[W\񂵂ĂL[[hɑΉuԂB
	 */
	public String getValueOfAssignedKeyword(String	keyword) {
		return	assignedKeywords.get(keyword);
	}

	/** ҏWf[^EZbg猻݂܂łɓǂݏoҏWf[^ێ鎫\ */
	private List<Keyword>	keywords = (new ArrayList<Keyword>());
	/** ҏWf[^EZbg̎\ɂ炽ȃnbVvbVB */
	void push() {	keywords.add(0, new Keyword(false));	}
	/** ҏWf[^EZbg̎\nbV|bvB */
	void pop() {	keywords.remove(0);	}
	/** 炽ȕҏWf[^̓eŎ\XV (TuE[`)B
	 * @param data 炽ȕҏWf[^nB
	 * @param idx ҏWf[^ōXV鎫\̃X^bNECfbNXnB[nƃubN܂L[[hXV邱ƂɂȂB
	 * @return ҏWf[^ōXV܂̃L[[hɑΉĂuԂB
	 * @exception pbP[W\񂵂ĂL[[hōXVꍇɁAReportException 𓊂B
	 */
	String intern(Data	data, int	idx) throws ReportException {
		String	keyword = data.getKeyword();
		if (assignedKeywords.get(keyword) != Keyword.NOT_FOUND_KEY) {
			throw (new ReportException(keyword + " is assigned keyword"));
		}
		return	keywords.get(idx).put(data.getKeyword(), data.getValue());
	}
	/** 炽ȕҏWf[^̓eŃubNɂ܂L[[h̎\XVB
	 * @param data 炽ȕҏWf[^nB
	 * @return ҏWf[^ōXV܂̃L[[hɑΉĂuԂB
	 * @exception pbP[W\񂵂ĂL[[hōXVꍇɁAReportException 𓊂B
	 */
	public String internSpecial(Data	data) throws ReportException {
		return	intern(data, (keywords.size() - 1));
	}
	/** 炽ȕҏWf[^̓eŎ\XVB
	 * @param data 炽ȕҏWf[^nB
	 * @return ҏWf[^ōXV܂̃L[[hɑΉĂuԂB
	 * @exception pbP[W\񂵂ĂL[[hōXVꍇɁAReportException 𓊂B
	 */
	public String intern(Data	data) throws ReportException {
		return	intern(data, 0);
	}

	/** L[[hɑΉ鎫\̓e폜 (TuE[`)B
	 * @param keyword \폜鍀ڂ̃L[[hnB
	 * @param idx ҏWf[^ōXV鎫\̃X^bNECfbNXnB[nƃubN܂L[[hXV邱ƂɂȂB
	 * @return 폜܂łɃL[[hɑΉĂuԂB
	 */
	private String abolish(String	keyword, int	idx) {
		return	keywords.get(idx).remove(keyword);
	}
	/** ubN܂L[[hɑΉ鎫\̓e폜B
	 * @param keyword \폜鍀ڂ̃L[[hnB
	 * @return 폜܂łɃL[[hɑΉĂuԂB
	 */
	public String abolishSpecial(String	keyword) {
		return	abolish(keyword, (keywords.size() - 1));
	}
	/** L[[hɑΉ鎫\̓e폜B
	 * @param keyword \폜鍀ڂ̃L[[hnB
	 * @return 폜܂łɃL[[hɑΉĂuԂB
	 */
	public String abolish(String	keyword) {	return	abolish(keyword, 0);	}

	/** \L[[hŌ (TuE[`)B
	 * @param keyword L[[hnB
	 * @param startIdx ҏWf[^ōXV鎫\̃X^bNECfbNXnB[nƃubN܂L[[hXV邱ƂɂȂB
	 * @return uԂB
	 * L[[hɑΉ鍀ڂ\ɂȂ null ԂB
	 */
	private String lookUp(String	keyword, int	startIdx) {
		String	value	= null;
		if ((value = assignedKeywords.get(keyword)) == null) {
			int		limit = keywords.size(), i;
			for (i = startIdx
			; ((i < limit)
				&& (value = keywords.get(i).get(keyword))
											== Keyword.NOT_FOUND_KEY)
			; ++i
			) {	;	}
		}
		return	value;
	}
	/** \ɃubN܂L[[hB
	 * @param keyword L[[hnB
	 * @return uԂB
	 * L[[hɑΉ鍀ڂ\ɂȂ null ԂB
	 */
	public String lookUpSpecial(String	keyword) {
		return	lookUp(keyword, (keywords.size() - 1));
	}
	/** \L[[hŌB
	 * @param keyword L[[hnB
	 * @return uԂB
	 * L[[hɑΉ鍀ڂ\ɂȂ null ԂB
	 */
	public String lookUp(String	keyword) {	return	lookUp(keyword, 0);	}

	/** ҏWf[^EZbgǂݍ񂾕ҏWf[^̎\̃RXgN^
	 */
	DataDictionary() {
		assignedKeywords	= (new Keyword(true));
		this.push();
	}
}
