/* report text builder
 * (c) 2010 Maoyam Tokyo, Japan (maoyam@mail.goo.ne.jp)
 */
package report;

import java.util.List;

/** eLXgҏW̃CAEg\z邽߂́utB[hvm[hB<BR>
 * em[h́AR[hBqm[h͂ȂB
 */
public class Field extends Node {
	/** tB[h̃R[ȟʒu̍ŏl */
	final static public int MIN_ROW = 0;
	/** tB[h̃R[ȟʒu */
	private int	row = Field.MIN_ROW;
	/** tB[h̃R[ȟʒũQb^B
	 * @return tB[h̃R[ȟʒuԂB
	 */
	public int getRow() {	return	this.row;	}

	/** tB[ȟ̍ŏl */
	final static public int MIN_WIDTH = 1;
	/** tB[ȟ */
	private int	width = 0;
	/** tB[ȟ̃Qb^B
	 * @return tB[ȟԂB
	 */
	public int getWidth() {	return	this.width;	}

	/** tB[hŒ蕶ێ邩ҏWtB[h̋敪 */
	private FieldType	type = FieldType.Literal;
	/** tB[hŒ蕶񂩕ҏWtB[h\敪̃Qb^B
	 * @return tB[hŒ蕶ێ邩ҏWtB[h̋敪ԂB
	 */
	public FieldType getType() {	return	this.type;	}

	/** tB[ȟŒ蕶񂠂邢͒uL[[h */
	private String		value = "";
	/** tB[ȟŒ蕶񂠂邢͒uL[[h̃Qb^B
	 * @return tB[ȟŒ蕶񂠂邢͒uL[[hԂB
	 */
	public String getValue() {	return	this.value;	}

	/** pbP[W̃[UҏWtB[h̃tH[}bgs߂Ɏw肵nh */
	private FieldFormat	userFormatter = null;
	/** pbP[W̃[UҏWtB[h̃tH[}bgs߂Ɏw肵nh̃Qb^B
	 * @return [Uw肵ҏWtB[hEtH[}b^̃nhԂB
	 */
	FieldFormat	getUserFormatter() {	return	this.userFormatter;	}

	/** tB[hɁAem[hAtB[hʒuAtB[hAŒ蕶񂩒utB[h̋敪AŒ蕶񂩒uL[[hA[U`tH[}b^Enhw肷RXgN^B
	 * @param ancestor em[h (R[h) nB
	 * @param row tB[ȟʒunB
	 * @param width tB[ȟnB
	 * @param type Œ蕶񂩒utB[h̋敪 (FieldType) nB
	 * @param value Œ蕶񂩒uL[[hnB
	 * @param userFormatter [U`̃tH[}b^nB
	 */
	public Field(Record			ancestor
				, int			row
				, int			width
				, FieldType		type
				, String		value
				, FieldFormat	userFormatter
				) {
		super(ancestor);
		this.row	= row;
		this.width	= width;
		this.type	= type;
		this.value	= value;
		this.userFormatter	= userFormatter;
	}
	/** tB[hɁAem[hAtB[hʒuAtB[hAŒ蕶񂩒utB[h̋敪AŒ蕶񂩒uL[[hw肷RXgN^B
	 * [U`tH[}b^Enh͎w肳ȂB
	 * @param ancestor em[h (R[h) nB
	 * @param row tB[ȟʒunB
	 * @param width tB[ȟnB
	 * @param type Œ蕶񂩒utB[h̋敪 (FieldType) nB
	 * @param value Œ蕶񂩒uL[[hnB
	 */
	public Field(Record		ancestor
				, int		row
				, int		width
				, FieldType	type
				, String	value
				) {
		this(ancestor, row, width, type, value, null);
	}
	/** tB[hɁAtB[hʒuAtB[hAŒ蕶񂩒utB[h̋敪AŒ蕶񂩒uL[[hA[U`tH[}b^Enhw肷RXgN^B
	 * em[h͕sȂ܂܂ƂȂB
	 * ̃tB[hƃ}[W邽߂ɎgptB[h𐶐鎖z肵ĂB
	 * @param row tB[ȟʒunB
	 * @param width tB[ȟnB
	 * @param type Œ蕶񂩒utB[h̋敪 (FieldType) nB
	 * @param value Œ蕶񂩒uL[[hnB
	 * @param userFormatter [U`̃tH[}b^nB
	 */
	public Field(int			row
				, int			width
				, FieldType		type
				, String		value
				, FieldFormat	userFormatter
				) {
		this(null, row, width, type, value, userFormatter);
	}
	/** tB[hɁAtB[hʒuAtB[hAŒ蕶񂩒utB[h̋敪AŒ蕶񂩒uL[[hw肷RXgN^B
	 * em[h͕sȂ܂܂ƂȂB[U`̃tH[}b^݂͑ȂB
	 * ̃tB[hƃ}[W邽߂ɎgptB[h𐶐鎖z肵ĂB
	 * @param row tB[ȟʒunB
	 * @param width tB[ȟnB
	 * @param type Œ蕶񂩒utB[h̋敪 (FieldType) nB
	 * @param value Œ蕶񂩒uL[[hnB
	 */
	public Field(int row, int width, FieldType type, String value) {
		this(row, width, type, value, null);
	}

	/** tB[hɎqm[hzŎw肵ꍇɗO𔭐B
	 * @param children qm[h̔znB
	 * @return ɗO𓊂̂ŁA߂l͂ȂB
	 * @exception  ReportException 𓊂 (tB[hɎqm[h݂͑Ȃ̂)
	 */
	public Field adda(Node	children[]) throws ReportException {
		throw (new ReportException("Field never has child node"));
		// return	null; // never reach
	}

	/** tB[hɉό̎qm[hw肵ꍇɗO𔭐B
	 * @param children ό̎qm[hnB
	 * @return ɗO𓊂̂ŁA߂l͂ȂB
	 * @exception  ReportException 𓊂 (tB[hɎqm[h݂͑Ȃ̂)
	 */
	public Field add(Node... children) throws ReportException {
		return	adda(children);
	}

	/** tB[hɎqm[hXgŎw肵ꍇɗO𔭐B
	 * @param children qm[h̃XgnB
	 * @return ɗO𓊂̂ŁA߂l͂ȂB
	 * @exception  ReportException 𓊂 (tB[hɎqm[h݂͑Ȃ̂)
	 */
	public Field add(List<Node>	children) throws ReportException {
		throw (new ReportException("Field never has child node"));
		// return	null; // never reach
	}

	/** ̃m[h̎qm[h̃tB[hɎ荞ƂꍇɗO𔭐B
	 * @param another ̃m[hnB
	 * @return ɗO𓊂̂ŁA߂l͂ȂB
	 * @exception  ReportException 𓊂 (tB[hɎqm[h݂͑Ȃ̂)
	 */
	public Field merge(Node	another) throws ReportException {
		return	add(another.getChildren());
	}

	/** tB[h̐mFB
	 * em[hR[hŁAqm[hȂAʒu̓[ŁA̓[傫ȐŁAutB[hłΒuL[[h󕶎ł͂ȂꍇɐȃtB[hƔfB
	 * @return mFꂽ̃tB[hԂB
	 * @exception łȂꍇ ReportException 𓊂B
	 */
	public Field verify() throws ReportException {
		super.verify();
		if ((getAncestor() instanceof Record) != true) {
			throw (new ReportException("invalid ancestor"
									+ "={" + getAncestor() + "}"
									)
					);
		}
		if (getChildren().size() != 0) {
			throw (new ReportException("must be zero children length"
									+ "=[" + getChildren().size() + "]"
									)
					);
		}
		if (row < Field.MIN_ROW) {
			throw (new ReportException("row=[" + row + "] is negtive"));
		}
		if (width < Field.MIN_WIDTH) {
			throw (new ReportException("invalid width=[" + width + "]"));
		}
		if ((type == FieldType.Keyword) && Node.isEmpty(value) == true) {
			throw (new ReportException("invalid " + type + " value"
									+ "=[" + Node.nullSafe(value) + "]"
									)
					);
		}
		return	this;
	}
}
