/* report text builder
 * (c) 2010 Maoyam Tokyo, Japan (maoyam@mail.goo.ne.jp)
 */
package report;

import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Arrays;

/** uL[[h̒`ƕҏWf[^̃nbV */
public class Keyword {
	/** pbP[W\L[[hB݂̃y[Wԍ */
	final static public String CURRENT_PAGE_NUM	= "(*CURRENT_PAGE_NUM*)";
	/** pbP[W\L[[hBy[W */
	final static public String TOTAL_PAGE_NUMS	= "(*TOTAL_PAGE_NUMS*)";
	/** pbP[W\L[[hBubNJn */
	final static public String BLOCK_START		= "(*BLOCK_START*)";
	/** pbP[W\L[[hBubNI */
	final static public String BLOCK_END		= "(*BLOCK_END*)";
	/** pbP[W\L[[hBR[hJn */
	final static public String RECORD_START		= "(*RECORD_START*)";
	/** pbP[W\L[[hBR[hI */
	final static public String RECORD_END		= "(*RECORD_END*)";

	/** Unix ̉s䕶 */
	final static public String	UNIX_NEW_LINE_CODES	= "\n";
	/** Unix ̉s䕶 */
	final static public char	UNIX_NEW_LINE_CODE	= '\n';
	/** Mac ̉s䕶 */
	final static public String	MAC_NEW_LINE_CODES	= "\r";
	/** Mac ̉s䕶 */
	final static public char	MAC_NEW_LINE_CODE	= '\r';
	/** DOS ̉s䕶 */
	final static public String	DOS_NEW_LINE_CODES	= "\r\n";

	/** 󔒕R[h ' ' */
	final static public char WHITE_SPACE	= ' ';
	/** ^uR[h '\t' */
	final static public char TAB_SPACE		= '\t';
	/** ASCII R[hől */
	final static public char MAX_ASCII		= '\u007e';
	/** `_ */
	final static public char TILDE_CODE		= '\u203e';
	/** p~L */
	final static public char YEN_SIGN		= '\u00a5';
	/** {ꔼpJi̔z */
	static private char[] singleWidthKanas = null;
	/** NXE[hB{ꔼpJi̔z\[gĂB */
	static {
		singleWidthKanas = (""
							+ "֬ܦ߰"
							).toCharArray();
		Arrays.sort(singleWidthKanas);
	}
	/** {u̔pR[hsB
	 * ASCII R[hƃ`_ '~'ApJiłΔpR[hƔ肷B
	 * @param code 肷镶R[hnB
	 * @return pR[hł true AłȂ false ԂB
	 */
	static public boolean isSingleWidthCodeJP(char	code) {
		return	(((((code == Keyword.YEN_SIGN)
				|| code == Keyword.TILDE_CODE)
				|| code <= Keyword.MAX_ASCII)
				|| Arrays.binarySearch(singleWidthKanas, code) >= 0)? true
				:													  false
				);
	}

	/** 󔒕ł邱Ƃ𔻒肷B
	 * ASCII Xy[X^uł΋󔒕łƔ肷B
	 * @param code 肷镶R[hnB
	 * @return 󔒕R[hł true AłȂ false ԂB
	 */
	static public boolean isWhiteSpace(char	code) {
		return	(((code == Keyword.TAB_SPACE) || code == WHITE_SPACE)
				?	true
				:	false
				);
	}

	/** uL[[hnbVɓo^ĂȂꍇ */
	final static public String NOT_FOUND_KEY	= null;
	/** 󕶎BnbV̒l null łꍇ󕶎ƂB */
	final static public String EMPTY_VALUE		= "";
	/** ҏWf[^o^nbV */
	private Map<String, String>	table = Collections.synchronizedMap(
									  new LinkedHashMap<String, String>()
									);

	/** ҏWf[^̃nbṼRXgN^B<BR>
	 * pbP[W\L[[h܂ރnbV𐶐Ȃ true ِɎw肷B
	 * @param createAssignedKeywordTable pbP[W\L[[hnbVɊ܂ނȂ true AłȂ false nB
	 */
	Keyword(boolean	createAssignedKeywordTable) {
		if (createAssignedKeywordTable == true) {
			table.put(Keyword.CURRENT_PAGE_NUM,	Keyword.EMPTY_VALUE);
			table.put(Keyword.TOTAL_PAGE_NUMS,	Keyword.EMPTY_VALUE);
			table.put(Keyword.BLOCK_START,		Keyword.EMPTY_VALUE);
			table.put(Keyword.BLOCK_END,		Keyword.EMPTY_VALUE);
			table.put(Keyword.RECORD_START,		Keyword.EMPTY_VALUE);
			table.put(Keyword.RECORD_END,		Keyword.EMPTY_VALUE);
		}
	}

	/** ҏWf[^̃nbVɁAL[[hƒl̑΂o^B
	 * @param key nbṼL[[h@(uL[[h) nB
	 * @param value nbV̒l (u) nB
	 * @return o^OɃL[[hƊ֘AÂĂuԂBL[[ho^ĂȂ null ԂB
	 */
	String put(String	key, String	value) {
		String	old_value = Keyword.NOT_FOUND_KEY;
		synchronized (table) {
			boolean	keyIsContained = table.containsKey(key);
			if (((old_value = table.put(key, value))
												== Keyword.NOT_FOUND_KEY)
			&& keyIsContained == true)
			{	old_value	= Keyword.EMPTY_VALUE;	}
		}
		return	old_value;
	}

	/** ҏWf[^̃nbVAL[[hɑΉ鍀ڂ폜B
	 * @param key 폜鍀ڂ̃L[[hnB
	 * @return 폜܂ŁAL[[hɊ֘AÂĂuԂBL[[ho^ĂȂ null ԂB
	 */
	String remove(String	key) {
		String	old_value = Keyword.NOT_FOUND_KEY;
		synchronized (table) {
			if ((table.containsKey(key) == true)
			&& (old_value = table.remove(key)) == Keyword.NOT_FOUND_KEY)
			{	old_value	= Keyword.NOT_FOUND_KEY;	}
		}
		return	old_value;
	}

	/** ҏWf[^̃nbVL[[hŌA̒l (u)@ԂB
	 * @param key uL[[hnB
	 * @return L[[hɊ֘AÂĂuԂBnbVɓo^ĂȂ null ԂB
	 */
	String get(String	key) {
		String	value = Keyword.NOT_FOUND_KEY;
		synchronized (table) {
			if ((table.containsKey(key) == true)
			&& (value = table.get(key)) == Keyword.NOT_FOUND_KEY)
			{	value	= Keyword.EMPTY_VALUE;	}
		}
		return	value;
	}

	/** ҏWf[^̃nbVɓo^ĂL[[hʂ̕ɒuB
	 * @param oldKey uL[[hnB
	 * @param newKey ũL[[hnB
	 * @return uÕL[[hɊ֘AÂĂu (炽ȃL[[hɂ֘At) ԂBuÕL[[hnbVɓo^ĂȂ null ԂB
	 */
	String changeKey(String	oldKey, String	newKey) {
		String	value = Keyword.NOT_FOUND_KEY;
		synchronized (table) {
			boolean	oldKeyIsContained = false;
			if ((oldKeyIsContained = table.containsKey(oldKey)) == true) {
				if ((value = table.get(oldKey)) == Keyword.NOT_FOUND_KEY)
				{	value	= Keyword.EMPTY_VALUE;	}
				if (oldKey.equals(newKey)) {
					return	value;
				}
				table.remove(oldKey);
			}
			if (table.containsKey(newKey) == true) {
				return	((oldKeyIsContained != true)
						?	Keyword.NOT_FOUND_KEY
						: ((value = table.get(newKey))
											== Keyword.NOT_FOUND_KEY)
						?	Keyword.EMPTY_VALUE
						:	value
						);
			}
			table.put(newKey
					, ((value == Keyword.NOT_FOUND_KEY)
						?	Keyword.EMPTY_VALUE
						:	value
						)
					);
		}
		return	value;
	}
}
