/* report text builder
 * (c) 2010 Maoyam Tokyo, Japan (maoyam@mail.goo.ne.jp)
 */
package report;

import java.util.List;
import java.util.ArrayList;

/** eLXgҏW̃CAEg\c[ׂ̂Ẵm[h̋KNXB
 * c[\m[h̊Kŵ͎ƂB<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Layout<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Block<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Record<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Field<BR>
 * &nbsp;&nbsp;&nbsp;&nbsp;<BR>
 * <BR>
 * Layout ͂̃TuENX HeaderLayout  FooterLayout Awb_ƃtb^̃CAEgws߂ɕێB<BR>
 * Block ͂ꎩgqm[hƂB<BR>
 * Block ̃TuENX FeedPageRecord ͉y[W䃌R[hALineFeedRecord ͉s䃌R[h\B<BR>
 */
public class Node {
	/** 񂪋ł邱Ƃ𔻒肷B
	 * @param str 肷镶nB
	 * @return  null 󕶎ł true AłȂ false ԂB
	 */
	static boolean isEmpty(String	str) {
		return	(((str == null) || str.equals("") == true)? true: false);
	}

	/** IuWFNg null łĂɕϊB
	 * @param obj null ł肤IuWFNgnB
	 * @return IuWFNg null ł "(nil)" AłȂ obj.toString() ԂB
	 */
	static String nullSafe(Object	obj) {
		return	((obj == null)? "(nil)": obj.toString());
	}

	/** em[h */
	private Node	ancestor = null;
	/** em[h̃Zb^B
	 * @param ancestor em[hnB
	 */
	void setAncestor(Node	ancestor) {	this.ancestor	= ancestor;	}
	/** em[h̃Qb^B
	 * @return em[hԂB
	 */
	Node getAncestor() {	return	this.ancestor;	}
	/** CAEg̃c[Ƀ[gECAEgTB
	 * @return [gECAEgԂB
	 */
	Layout getRootLayout() {
		Node	ancestor = this.ancestor;

		while ((ancestor != null)
				&& ((ancestor instanceof Layout) != true
					|| ancestor.ancestor != ancestor
					)
		) {		ancestor	= ancestor.ancestor;	}

		return	(Layout)ancestor;
	}

	/** qm[h̃Xg */
	private List<Node>	children = (new ArrayList<Node>());
	/** qm[h̃Xg̃Zb^
	 * @param children m[h̎qm[h̃XgnB
	 */
	void setChildren(List<Node>	children) {	this.children	= children;	}
	/** qm[h̃Xg̃Qb^
	 * @return m[h̎qm[h̃XgԂB
	 */
	public List<Node>	getChildren() {	return	this.children;	}

	/** em[hw肵ăm[h𐶐RXgN^B
	 * @param ancestor em[hnB
	 */
	Node(Node	ancestor) {	this.ancestor	= ancestor;	}
	/** m[h̃RXgN^B
	 * em[h͕s (null) ɂȂB
	 */
	Node() {	this(null);	}

	/** m[h̐em[hsł邱Ƃem[hł邱Ƃ𔻒肷B<BR>
	 * em[hsł邱Ƃem[h́Ay[WƉsw肷郌R[h (Record.PAGE_FEED_RECORD, Record.LINE_FEED_PAGE) ̂ꂩB
	 * @param node 肷m[hnB
	 * @return em[hsł邱Ƃem[hł true AłȂ false ԂB
	 */
	boolean isOrphanNode(Node	node) {
		return	(((node == Record.getPageFeed())
				|| node == Record.getLineFeed())?	true
				:									false
				);
	}

	/** qm[h̐em[h̃m[hɐݒ肷B
	 * @param node qm[hnB
	 * @return ̃m[hem[hɐݒ肵qm[hԂB
	 */
	private Node setAncestorOfChild(Node	node) {
		if (isOrphanNode(node) != true) {	node.setAncestor(this);	}
		return	node;
	}

	/** qm[h̔zǉB
	 * @param children qm[h̔znB
	 * @return qm[hǉ̃m[hԂB
	 * @exception CAEg̐Ȃꍇ ReportException 𓊂B
	 */
	Node adda(Node	children[]) throws ReportException {
		if (children != null) {
			for (int i = 0; i < children.length; ++i) {
				this.children.add(setAncestorOfChild(children[i]));
			}
		}
		return	this;
	}
	/** ό̎qm[hǉB
	 * @param children ό̎qm[hnB
	 * @return qm[hǉ̃m[hԂB
	 * @exception CAEg̐Ȃꍇ ReportException 𓊂B
	 */
	Node add(Node... children) throws ReportException {
		return	adda(children);
	}

	/** qm[h̃XgǉB
	 * @param children qm[h̃XgnB
	 * @return qm[hǉ̃m[hԂB
	 * @exception CAEg̐Ȃꍇ ReportException 𓊂B
	 */
	Node add(List<? extends Node>	children) throws ReportException {
		if (children != null) {
			Node	oldAncestor = null;
			for (Node child : children) {
				if ((oldAncestor != null) && oldAncestor != child.ancestor)
				{	throw (new ReportException("differ ancestor of children"
								+ ": oldAncestor={" + oldAncestor + "}"
								+ ", child.ancestor={" + child.ancestor
								+					"}"
								)
							);
				}
				if ((oldAncestor == null) && child.ancestor != null) {
					oldAncestor	= child.ancestor;
				}
				setAncestorOfChild(child);
			}
			this.children.addAll(children);
			if (oldAncestor != null) {	oldAncestor.children.clear();	}
		}
		return	this;
	}
	/** ʂ̃m[h̎qm[hÃm[hɈڂB
	 * @param another ʂ̃m[hnB
	 * @return ʂ̃m[h̎qm[hڂ̃m[hԂB
	 * @exception CAEg̐łȂꍇ ReportException ԂB
	 */
	Node merge(Node	another) throws ReportException {
		if (another != null) {	add(another.children);	}
		return	this;
	}

	/** m[h̐mFB
	 * em[hsł邱ƂeȂm[hem[hĂ΁AłƔ肷B
	 * @return ł邱ƂmF̃m[hԂB
	 * @exception łȂm[hłꍇ ReportException 𓊂B
	 */
	Node verify() throws ReportException {
		if ((isOrphanNode(this) != true) && ancestor == null)
		{	throw (new ReportException("no ancestor"));	}
		return	this;
	}
}
