/* report text builder
 * (c) 2010 Maoyam Tokyo, Japan (maoyam@mail.goo.ne.jp)
 */
package report;

import java.util.List;

/** eLXgҏW̃CAEg\zuR[hvm[hB<BR>
 * em[h́AubNBqm[h̓tB[hB
 */
public class Record extends Node {
	/** y[WCAEgɎw肷邽߂̐䃌R[h */
	final static PageFeedRecord PAGE_FEED_RECORD = (new PageFeedRecord());
	/** y[W䃌R[h̃Qb^B
	 * @return Record.PAGE_FEED_RECORD ԂB
	 */
	static public Record getPageFeed() {
		return PageFeedRecord.PAGE_FEED_RECORD;
	}

	/** sCAEgɎw肷邽߂̐䃌R[h */
	final static LineFeedRecord LINE_FEED_RECORD = (new LineFeedRecord());
	/** HƐ䃌R[h̃Qb^B
	 * @return Record.LINE_FEED_RECORD ԂB
	 */
	static public Record getLineFeed() {
		return LineFeedRecord.LINE_FEED_RECORD;
	}

	/** R[hy[W܂ł\Ȃۂ̋敪 */
	private boolean splitable = true;
	/** R[hy[W܂ł\Ȃۂ̋敪̃Zb^B
	 * @param splitable R[hy[W܂ł\Ȃۂ̋敪nB
	 */
	void setSplitable(boolean	splitable) { this.splitable	= splitable; }
	/** R[hy[W܂ł\Ȃۂ̋敪̃Qb^B
	 * @return R[hy[W܂ł\Ȃۂ̋敪ԂB
	 */
	boolean getSplitable() {	return	this.splitable;	}

	/** R[h̕ҏWtB[ȟ */
	private int	cntOfFieldsTypedKeyword = 0;
	/** R[h̕ҏWtB[ȟ̃Qb^B
	 * @return R[h̕ҏWtB[ȟԂB
	 */
	int getCntOfFieldsTypedKeyword() {
			return	this.cntOfFieldsTypedKeyword;
	}
	/** R[h̕ҏWtB[hCNgB
	 * @param child R[h̎qtB[hnB
	 */
	private void incrementCntOfFieldsTypedKeyword(Field	child) {
		if (child.getType() == FieldType.Keyword) { ++cntOfFieldsTypedKeyword; }
	}
	/** R[h̕ҏWtB[hCNgB
	 * @param children R[h̎qtB[h̔znB
	 */
	private void incrementCntOfFieldsTypedKeyword(Field	children[]) {
		for (int i = 0; i < children.length; ++i) {
			incrementCntOfFieldsTypedKeyword(children[i]);
		}
	}
	/** R[h̕ҏWtB[hCNgB
	 * @param children R[h̎qtB[h̃XgnB
	 */
	private void
			incrementCntOfFieldsTypedKeyword(List<? super Field> children) {
		for (Object child : children) {
			incrementCntOfFieldsTypedKeyword((Field)child);
		}
	}

	/** [U`郌R[h\nh */
	private RecordBuilder	builder = null;
	/** [U`郌R[h\nh̃Zb^B
	 * @param builder R[h\nhnB
	 */
	void setBuilder(RecordBuilder	builder) { this.builder	= builder; }
	/** [U`郌R[h\nh̃Qb^B
	 * @return R[h\nhԂB
	 */
	RecordBuilder getBuilder() {	return	this.builder;	}

	/** em[hƃ[U`R[h\nhƃy[W܂肤邩ۂ̋敪w肵ăR[h𐶐RXgN^B
	 * @param ancestor em[hnB
	 * @param builder [U`̃R[h\nhnB
	 * @param splitable R[hy[W܂Ȃ true AłȂ false nB
	 */
	public Record(Block	ancestor, RecordBuilder	builder, boolean splitable)
	{
		super(ancestor);
		this.builder	= builder;
		this.splitable	= splitable;
	}
	/** em[hƃ[U`R[h\nhw肵ăR[h𐶐RXgN^B<BR>
	 * R[h̓y[W܂Ă܂ȂƂɂȂB
	 * @param ancestor em[hnB
	 * @param recordBuilder [U`̃R[h\nhnB
	 */
	public Record(Block	ancestor, RecordBuilder	recordBuilder) {
		this(ancestor, recordBuilder, true);
	}
	/** em[hƃy[W܂肤邩ۂ̋敪w肵ăR[h𐶐RXgN^B<BR>
	 * [U`̃R[h\nh݂͑ȂB
	 * @param ancestor em[hnB
	 * @param splitable R[hy[W܂Ȃ true AłȂ false nB
	 */
	public Record(Block	ancestor, boolean splitable) {
		this(ancestor, null, splitable);
	}
	/** [U`R[h\nhƃy[W܂肤邩ۂ̋敪w肵ăR[h𐶐RXgN^B<BR>
	 * em[h͕s (null) ɂȂB
	 * @param recordBuilder [U`̃R[h\nhnB
	 * @param splitable R[hy[W܂Ȃ true AłȂ false nB
	 */
	public Record(RecordBuilder	recordBuilder, boolean splitable) {
		this(null, recordBuilder, splitable);
	}
	/** y[W܂肤邩ۂ̋敪w肵ăR[h𐶐RXgN^B<BR>
	 * em[h͕s (null) ɂȂB<BR>
	 * [U`̃R[h\nh݂͑ȂB
	 * @param splitable R[hy[W܂Ȃ true AłȂ false nB
	 */
	public Record(boolean splitable) {
		this(null, null, splitable);
	}
	/** [U`R[h\nhw肵ăR[h𐶐RXgN^B<BR>
	 * em[h͕s (null) ɂȂB<BR>
	 * R[h̓y[W܂Ă܂ȂƂɂȂB
	 * @param recordBuilder [U`̃R[h\nhnB
	 */
	public Record(RecordBuilder	recordBuilder) {
		this(null, recordBuilder, true);
	}
	/** em[hw肵ăR[h𐶐RXgN^B<BR>
	 * [U`̃R[h\nh݂͑ȂB<BR>
	 * R[h̓y[W܂Ă܂ȂƂɂȂB
	 * @param ancestor em[hnB
	 */
	public Record(Block	ancestor) {	this(ancestor, null, true);	}
	/** R[h𐶐RXgN^B<BR>
	 * em[h͕s (null) ɂȂB<BR>
	 * [U`̃R[h\nh݂͑ȂB<BR>
	 * R[h̓y[W܂Ă܂ȂƂɂȂB<BR>
	 */
	public Record() {	this(null, null, true);	}

	/** qm[h̃tB[h̔z̃R[hɒǉB
	 * @param children qm[h̃tB[h̔znB
	 * @return tB[hǉ̃R[hԂB
	 * @exception CAEg̕s ReportException 𓊂.
	 */
	public Record adda(Field	children[]) throws ReportException {
		incrementCntOfFieldsTypedKeyword(children);
		return	(Record)super.adda(children);
	}
	/** ό̎qm[h̃tB[h̃R[hɒǉB
	 * @param children ό̎qm[h̃tB[hnB
	 * @return tB[hǉ̃R[hԂB
	 * @exception CAEg̕s ReportException 𓊂.
	 */
	public Record add(Field... children) throws ReportException {
		return	adda(children);
	}

	/** qm[h̃tB[h̃Xg̃R[hɒǉB
	 * @param children qm[h̃tB[h̃XgnB
	 * @return tB[hǉ̃R[hԂB
	 * @exception CAEg̕s ReportException 𓊂B
	 */
	public Record add(List<Field>	children) throws ReportException {
		incrementCntOfFieldsTypedKeyword(children);
		return	(Record)super.add(children);
	}
	/** ̃R[h̎qm[hÃR[hɈڂB
	 * @param another ̃R[hnB
	 * @return ̃R[h̎qm[hڂ̃R[hԂB
	 * @exception CAEg̕s ReportException 𓊂B
	 */
	public Record merge(Record	another) throws ReportException {
		incrementCntOfFieldsTypedKeyword(another.getChildren());
		return	(Record)super.merge(another);
	}

	/** R[hł邱ƂmFB<BR>
	 * em[hubNŁAҏWtB[ȟ[ŁAqm[hׂătB[hŁAem[hsł邱ƂeȂR[hł̓[gECAEg̕qm[ĥ̃tB[hAqm[h̃tB[hmʒuƌŏdȂȂ΁ÃR[h͐łƔ肷B
	 * @return ł邱ƂmFꂽ̃R[hԂB
	 * @exception łȂR[hłꍇ ReportException ԂB
	 */
	public Record verify() throws ReportException {
		super.verify();
		if ((getAncestor() instanceof Block) != true) {
			throw (new ReportException("invalid ancestor"
									+ "={" + getAncestor() + "}"
									)
					);
		}
		if (cntOfFieldsTypedKeyword < 0) {
			throw (new ReportException("cntOfFieldsTypedKeyword"
									+ "=[" + cntOfFieldsTypedKeyword + "]"
									+ " is negative"
									)
					);
		}
		else {
			Layout	rootLayout = getRootLayout();
			Field	fld = null, prevFld = null;
			Node	child = null;
			int		children_size = getChildren().size();
			for (int i = 0; i < children_size; ++i) {
				child = getChildren().get(i);
				if ((child instanceof Field) != true) {
					throw (new ReportException("invalid child(" + i + ")"
										+ "={" + child + "}"
										)
							);
				}
				(fld = (Field)child).verify();

				if (rootLayout != null) {
					if ((rootLayout.getWidth() != Layout.UNLIMITED_WIDTH)
					&& rootLayout.getWidth()
										< (fld.getRow() + fld.getWidth()))
					{	throw (new ReportException("invalid child"
										+ "(" + i + ")"
										+ ": row=[" + fld.getRow() + "]"
										+ ", width=[" + fld.getWidth() + "]"
										)
								);
					}
					if (i > 0) {
						prevFld = (Field)(getChildren().get(i - 1));
						if ((prevFld.getRow() + prevFld.getWidth())
															> fld.getRow())
						{	throw (new ReportException("invalid childen"
									+ "(" + i + ")"
									+ "={ row=[" + fld.getRow() + "]"
									+ ", width=[" + fld.getWidth() + "]"
									+ "}"
									+ "(" + (i - 1) + ")"
									+ "={ row=[" + prevFld.getRow() + "]"
									+ ", width=[" + prevFld.getWidth() + "]"
									+ "}"
									));
						}
					}
				}
			}
		}
		return	this;
	}
}

/** eLXgҏW̃CAEg̐su䃌R[hv̊m[hB<BR>
 * em[h́Asł邱ƂeBqm[h݂͑ȂB
 */
class ControlRecord extends Record {
	/** 䃌R[h̃RXgN^B */
	ControlRecord() {	super();	}

	/** 䃌R[h̐mFB<BR>
	 * em[hݒ肳Ă΁AR[hƂĐmFB
	 * łȂΏ true ԂB
	 * @return ł邱ƂmFꂽ̐䃌R[hԂB
	 * @exception em[hݒ肳ĂĐȂꍇ ReportException 𓊂B
	 */
	public ControlRecord verify() throws ReportException {
		if (getAncestor() != null) {	super.verify();	}
		return	this;
	}
}

/** eLXgҏW̃CAEg̉y[Wsuy[WER[hvm[hB<BR>
 * em[h́Asł邱ƂeBqm[h݂͑ȂB
 */
class PageFeedRecord extends ControlRecord {
	/** y[WER[h̃RXgN^ */
	PageFeedRecord() {	super();	}
}

/** eLXgҏW̃CAEg̋ssusR[hvm[hB<BR>
 * em[h́Asł邱ƂeBqm[h݂͑ȂB
 */
class LineFeedRecord extends ControlRecord {
	/** sR[h̃RXgN^ */
	LineFeedRecord() {	super();	}
}
