/* report text builder
 * (c) 2010 Maoyam Tokyo, Japan (maoyam@mail.goo.ne.jp)
 */
package report;

import java.util.Iterator;
import java.util.ArrayList;
import java.util.List;

/** CAEgɕҏWf[^EZbgKpăeLXgҏWsB<BR>
 * pbP[WE[U̓CAEg\z FieldFormatter C^tF[XNX̃CX^Xw肷鎖ŁAҏWtB[hꂼ̒u[U`tH[}b^ (FieldFormatter#format()) ŕҏW邱ƂłB<BR>
 * pbP[WE[U̓CAEg\z RecordBuilder C^tF[XNX̃CX^Xw肷鎖ŁAR[ĥׂẴtB[hҏWꂽʂ[U`菇 (RecordBuilder#concatField()) ŕҏWʏo͍sɍ\邱ƂłB
 */
public class Transformer {
	/** egXt@ ([gEgXt@ł nullAwb_/tb^ECAEgł΃[gEgXt@) */
	private Transformer	ancestor = null;
	/** ̃gXt@[gEgXt@ł邩ۂ𔻒肷B
	 * @return [gEgXt@ł true AłȂ false ԂB
	 */
	private boolean isRootTransformer() {
		return	((this.ancestor == null)?	true: false);
	}
	/** [gEgXt@TB
	 * @return [gEgXt@ԂB
	 */
	Transformer getRootTransformer() {
		return	((isRootTransformer() == true)?	this: ancestor);
	}

	/** gXt@QƂ郌CAEg */
	private Layout	rootLayout = null;
	/** gXt@QƂ郌CAEg̃Qb^B
	 * @return gXt@QƂ郌CAEgԂB
	 */
	Layout getRootLayout() {	return	this.rootLayout;	}
	/** wb_ƃtb^o͂łősAwb_/tb^ɏo͂łs߂B
	 * y[W䂪svȃCAEgł΁ALayout.WITHOUT_PAGE_CONTROL ԂB
	 * @return o͂łősԂB
	 */
	int getMaxCntLines() {
		return	((rootLayout instanceof HeaderLayout)
				?	((HeaderLayout)rootLayout).getLines()
				: (rootLayout.getLinesPerPage()
										== Layout.WITHOUT_PAGE_CONTROL)
				?	Layout.WITHOUT_PAGE_CONTROL
				:	(rootLayout.getLinesPerPage()
								- ((rootLayout.getHeaderLayout() != null)
									?	rootLayout.getHeaderLayout()
															.getLines()
									:	0
									)
								- ((rootLayout.getFooterLayout() != null)
									?	rootLayout.getFooterLayout()
															.getLines()
									:	0
									)
								)
				);
	}

	/** QƂ郌CAEgƐegXt@w肵ăgXt@̃RXgN^B
	 * @param layout QƂ郌CAEgnB
	 * @param ancestor egXt@ (wb_/tb^Ȃ΃[gEgXt@A[gEgXt@Ȃ null) nB
	 */
	Transformer(Layout	layout, Transformer	ancestor) {
		this.rootLayout	= layout;
		this.ancestor	= ancestor;
	}
	/** QƂ郌CAEgw肵ăgXt@̃RXgN^B
	 * gXt@͐egXt@ɂȂB
	 * @param layout QƂ郌CAEgnB
	 */
	public Transformer(Layout	layout) {	this(layout, null);	}

	/** ҏWf[^EZbgҏWf[^ǂݏof[^E[_[B */
	private DataSetReader	dataSetReader = null;
	/** ҏWf[^EZbgŌɓǂݏof[^̃Qb^B
	 * @return ŌɓǂݏoҏWf[^ԂB
	 */
	private Data getCurrentData() {
		return	getRootTransformer().dataSetReader.getCurrent();
	}
	/** ҏWf[^EZbg玟̕ҏWf[^ǂݏoB
	 * @return ̕ҏWf[^ԂB
	 */
	private Data getNextData() {
		return	getRootTransformer().dataSetReader.getNext();
	}
	/** ҏWf[^EZbg̃f[^E[_[ݒ肷B<BR>
	 * ̃gXt@[gEgXt@łȂ΁A[_[͐ݒ肳ȂB
	 * @param dataSet ҏWf[^EZbgnB
	 */
	private void initDataSetReader(DataSet	dataSet) {
		this.dataSetReader	= ((isRootTransformer() == true)
								?	(new DataSetReader(dataSet))
								:	null
								);
	}

	/** ҏWf[^EZbgǂݍ񂾓eێ鎫\ */
	private DataDictionary	dataDict = null;
	/** ҏWf[^EZbgǂݍ񂾓eێ鎫\ݒ肷B
	 * ̃gXt@[gEgXt@łȂΎ\͐ݒ肳ȂB
	 */
	private void initDataDict() {
		this.dataDict	= ((isRootTransformer() == true)
							?	(new DataDictionary())
							:	null
							);
		return;
	}
	/** [gEgXt@ێҏWf[^\̃Qb^B
	 * @return ҏWf[^ێ鎫\ԂB
	 */
	DataDictionary getDataDictionary() {
		return	getRootTransformer().dataDict;
	}
	/** 炽ȃubNł̕ҏWf[^ێX^bN\ɒǉB */
	private void push() {	getDataDictionary().push();	}
	/** ubNł̕ҏWf[^ێX^bN\폜B */
	private void pop() {	getDataDictionary().pop();	}
	/** ҏWf[^\ɒǉB
	 * @param data ǉҏWf[^nB
	 * @return ɓo^ĂL[[hłΒǉOɎ\ێĂuԂBłȂ null ԂB
	 * @exception \ւ̃f[^ǉňُ킪N ReportException 𓊂B
	 */
	private String intern(Data	data) throws ReportException {
		return	((data.isSpecial() == true)
				?	getDataDictionary().internSpecial(data)
				:	getDataDictionary().intern(data)
				);
	}
	/** y[Wݒ肷B
	 * @param totalPageNums y[WnB
	 * @return ܂łɐݒ肳Ăy[W\ԂBݒ肳ĂȂ null ԂB
	 */
	private String setTotalPageNums(int	totalPageNums) {
		return	getDataDictionary().setTotalPageNums(totalPageNums);
	}
	/** ݂̃y[Wԍݒ肷B
	 * @param pageNo ݂̃y[WԍnB
	 * @return ܂łɐݒ肳Ăy[Wԍ\ԂBݒ肳ĂȂ null ԂB
	 */
	private String setCurrentPageNum(int	pageNo) {
		return	getDataDictionary().setCurrentPageNum(pageNo);
	}
	/** ݂̃y[WԍCNgB
	 * @return CNgÕy[Wԍ\ԂB݂̃y[Wԍݒ肳ĂȂȂ null ԂB
	 */
	String incremantCurrentPageNum() {
		String	pageNum = lookUp(Keyword.CURRENT_PAGE_NUM);
		if (Node.isEmpty(pageNum) == true) {	pageNum	= "1";	}
		return	setCurrentPageNum(Integer.parseInt(pageNum) + 1);
	}
	/** ҏWf[^̎\L[[hŌāAu߂B
	 * @param keyword L[[hnB
	 * @return L[[hɑΉuԂBL[[h\ɓo^ĂȂ null ԂB
	 */
	String lookUp(String	keyword) {
		return	getDataDictionary().lookUp(keyword);
	}

	/** ubŇJԂҏWf[^狁߂B<BR>
	 * ubN̊Jnwǂݏo܂ł̕ҏWf[^͎\ɓo^B
	 * @return ubŇJԂԂBłɃubNɂꍇ́A1 ԂB
	 */
	private int getBlockIterationCnt() throws ReportException {
		String	keyword = null;
		Data	data = getCurrentData();
		int		result = 0;

		while (((data != null)
		&& (keyword = data.getKeyword()).equals(Keyword.BLOCK_START)
																!= true)
		&& keyword.equals(Keyword.RECORD_START) != true)
		{
			if ((keyword.equals(Keyword.RECORD_END) != true)
			&& keyword.equals(Keyword.BLOCK_END) != true)
			{	intern(data);	}
			data	= getNextData();
		}
		if ((data != null)
		&& data.getKeyword().equals(Keyword.BLOCK_START) == true)
		{
			result	= Integer.parseInt(data.getValue());
			getNextData();
		}
		else {	result	= 1;	}

		return	result;
	}

	/** ubN̏I܂ŕҏWf[^ǂݏoB<BR>
	 * ubNI܂ł̕ҏWf[^͎\ɓo^B
	 * @exception ҏWf[^̓ǂݏoɈُ킪N ReportException 𓊂B
	 */
	private void skipUntilBlockEnd() throws ReportException {
		String	keyword = null;
		Data	data = getCurrentData();

		while ((data != null)
		&& (keyword = data.getKeyword()).equals(Keyword.BLOCK_END) != true)
		{
			if (((keyword.equals(Keyword.RECORD_START) != true)
			&& keyword.equals(Keyword.RECORD_END) != true)
			&& keyword.equals(Keyword.BLOCK_START) != true)
			{	intern(data);	}
			data	= getNextData();
		}
		if (data != null) {	getNextData();	}

		return;
	}

	/** R[h̏I܂ŕҏWf[^ǂݍށB<BR>
	 * R[hI܂ł̕ҏWf[^͎\ɓo^B
	 * @exception ҏWf[^̓ǂݏoɈُ킪N ReportException 𓊂B
	 */
	private void updateDataDictionary() throws ReportException {
		String	keyword = null;
		Data	data = getCurrentData();

		while ((((data != null)
		&& (keyword = data.getKeyword()).equals(Keyword.RECORD_END) != true)
		&& keyword.equals(Keyword.BLOCK_END) != true)
		&& keyword.equals(Keyword.BLOCK_START) != true)
		{
			if (keyword.equals(Keyword.RECORD_START) != true) {
				intern(data);
			}
			data	= getNextData();
		}
		if ((data != null) && keyword.equals(Keyword.RECORD_END) == true)
		{	getNextData();	}

		return;
	}

	/** pbP[WҏWς݂̒ůesR[h̕ҏWʂɍ\ftHg̎菇B<BR>
	 * stB[h̖ɕKvȂ̋󔒕 (Keyword.WHITE_SPACE) ǉāÃtB[h̊es̓eǉB<BR>
	 * R[h̊eš́ÃtB[ȟʒuƕ̘aɂȂB
	 * @param lines R[h̕ҏWʂ̊es̃XgnB
	 * @param values ҏWς݂̃tB[h̊es̃XgnB
	 * @param field ̃tB[h̃CAEgwenB
	 * @return ̃tB[h̕ҏWʂ̊esōXVꂽR[hҏWʂ̊es̃XgԂB
	 */
	private List<Line> concatField(List<Line>	lines
								, List<Line>	values
								, Field			field
								) {
		Line	line = null, value = null;
		int		size = values.size(), i = 0, j = 0, k = 0;

		for (size = values.size(), i = 0; i < size; ++i) {
			line	= lines.get(i);
			value	= values.get(i);
			for (k = field.getRow() - line.getDigits(), j = 0; j < k; ++j) {
				line.getValue().append(Keyword.WHITE_SPACE);
			}
			line.getValue().append(value.getValue());
			line.setDigits(field.getRow() + value.getDigits());
		}
		return	lines;
	}

	/** R[h̕ҏWςׂ݂̂ẴtB[h̕ҏWʂŁAR[hҏWʂ̊es̃Xg\B<BR>
	 * <B>[U`R[h\nhCAEg̃R[hwŐݒ肳Ă΁AҏWʂ̃tB[hꂼΏۈ (target) ɓnănh̃\bh (RecordBuilder#concatField() ĂяoB<BR>
	 * ܂AtB[h̏Jn̓nh RecordBuilder#begin() ĂяoAtB[hI̓nh RecordBuilder#end() ĂяoB
	 * ̂ƂAnh̏Ώۈ (target)  Field nB</B>
	 * @param fmtFlds ҏWς݂̃tB[h̓ẽXgnB
	 * @return R[hҏWʂ̊es̃XgԂB
	 * @exception [U`nhŗO΂ (ReportUserException) 𓊂B
	 */
	private List<Line> concatFields(List<FormattedField>	fmtFlds)
												throws ReportException {
		FormattedField	fmtFld = null;
		RecordBuilder	recBuilder = null;
		List<Line>		recBldrResult = null;
		List<Line>		lines = null;
		Context			context = null;
		Field			field = null;
		int				size = 0, maxLines = 0, limit = 0, i = 0;

		for (i = 0, limit = fmtFlds.size(); i < limit; ++i) {
			if ((size = fmtFlds.get(i).getValues().size()) > maxLines) {
				maxLines = size;
			}
		}
		lines	= (new ArrayList<Line>(maxLines));
		for (i = 0; i < maxLines; ++i) {
			lines.add(new Line((new StringBuffer("")), 0));
		}

		/* we can invoke user's `RecordBuilder#begin(Field)'-method */
		limit	= fmtFlds.size();
		if ((limit > 0)
		&& (recBuilder = ((Record)((field =(fmtFlds.get(0)).getField())
										.getAncestor())
									).getBuilder()
						) != null)
		{
			recBuilder.begin(field
							, (context
									= (new Context(field
												, (dataDict
													= getDataDictionary()
													)
												)
									)
								)
							);
		}
		for (i = 0; i < limit; ++i) {
			fmtFld	= fmtFlds.get(i);
			/* we can invoke user's `RecordBuilder#concatField(Field)'-
			 * method
			 */
			if (recBuilder != null) {
				context.setIndexOfTarget(i);
				recBldrResult = recBuilder.concatField(lines
													, fmtFld.getValues()
													, fmtFld.getField()
													, context
													);
			}
			if (recBldrResult == null) {
				concatField(lines, fmtFld.getValues(), fmtFld.getField());
			}
			else {	lines	= recBldrResult;	}
		}
		/* we can invoke user's `RecordBuilder#end(Field) */
		if ((recBuilder != null) && limit > 0) {
			context.setIndexOfTarget(i); recBuilder.end(field, context);
		}

		return	lines;
	}

	/** eLXgҏWʂێĂy[WEZbg̃y[WACAEgŎw肳ꂢőy[W𒴂ĂΗO𔭐B
	 * @param pageSet eLXgҏWʂێĂy[WEZbgnB
	 * @exception CAEgŎw肳ꂽőy[W𒴂Ă ReportException 𓊂B
	 */
	private PageSet checkPageOverFlow(PageSet	pageSet)
												throws ReportException {
		if ((getRootLayout().getLinesPerPage()
									!= Layout.WITHOUT_PAGE_CONTROL)
		&& getRootLayout().getMaxPage() <= pageSet.getTotalPageNums())
		{
			throw (new ReportException("page over flow:maxPages"
								+ "=[" + getRootLayout().getMaxPage() + "]"
								)
					);
		}
		return	pageSet;
	}

	/** Ō̃y[Wŉy[WsB
	 * @param pageSet y[Wsy[WEZbg (ǉꂽŌ̃y[W͋ɂȂĂ) ԂB
	 * @exception őy[W𒴂Ă܂ ReportException ԂB
	 */
	PageSet feedPage(PageSet	pageSet) throws ReportException {
		return	checkPageOverFlow(pageSet.feedPage());
	}

	/** Ō̃y[WɋsǉB
	 * @param pageSet Ō̃y[Wɋsǉy[WEZbgԂB
	 * @exception őy[W𒴂Ă܂ ReportException ԂB
	 */
	PageSet feedLine(PageSet	pageSet) throws ReportException {
		return	checkPageOverFlow(pageSet.feedLine());
	}

	/** Ō̃y[Wɍs̃XgǉB
	 * @param pageSet Ō̃y[Wɍs̃Xgǉy[WEZbgԂB
	 * @exception őy[W𒴂Ă܂ ReportException ԂB
	 */
	PageSet addLines(PageSet	pageSet , List<Line>	lines)
											throws ReportException {
		return	checkPageOverFlow(pageSet.addLines(lines));
	}

	/** R[hҏWāAҏWʂ̊es̃Xg𐶐B<BR>
	 * <B>pbP[WE[UR[h\nh`Ă΁AΏۂ̃R[hΏۈ (target) ɓnāAJnƏI\bh (RecordBuilder#begin()  RcordBuilder#end()) ĂяoB</B>
	 * @param record ҏW郌R[h̃CAEgwnB
	 * @return R[hҏWʂ̊es̃XgԂB
	 * @exception R[hҏWňُ킪ꍇ ReportException (邢 ReportUserException) 𓊂B
	 */
	private List<Line>	createLines(Record	record, PageSet	pageSet)
													throws ReportException {
		List<FormattedField>	fmtFlds = (new ArrayList<FormattedField>());
		FormattedField			fmtFld = null;
		List<Line>				result = null;
		Context					context = null;
		Field					field = null;
		int						cntKeywordFields = 0
								, cntLinesOfLastPage = 0
								, i = 0
								;

		/* we can invoke user's 'RecordBuilder#begin(Record)'-methods */
		if (record.getBuilder() != null) {
			record.getBuilder().begin(record
									, (context
										= (new Context(record
													, getDataDictionary()
													)
											)
										)
									);
		}

		for (Node child : record.getChildren()) {
			if ((child instanceof Field) != true) {
				throw (new ReportException("invalid child"
											+ "={" + child + "}"
											)
						);
			}
			fmtFld	= (new FormattedField((field = (Field)child)));
			fmtFlds.add(fmtFld.format(this, i++));
			if ((field.getType() == FieldType.Keyword)
			&& fmtFld.isEmpty() != true)
			{	++cntKeywordFields;	}
		}

		if ((record.getCntOfFieldsTypedKeyword() == 0)
		|| cntKeywordFields > 0)
		{
			result	= concatFields(fmtFlds);
			if (((record.getSplitable() != true)
			&& (cntLinesOfLastPage = pageSet.getCntOfLines()) > 0)
			&& (getMaxCntLines() - cntLinesOfLastPage) < result.size())
			{	feedPage(pageSet);	}
		}
		else {	result	= (new ArrayList<Line>());	}

		/* we can invoke user's 'RecordBuilder#end(Record)'-methods */
		if (context != null) { record.getBuilder().end(record, context); }

		return	result;
	}

	/** CAEg邢̓ubNQƂĕҏWf[^EZbgeLXgɕҏWB<BR>
	 * <B>pbP[WE[UubN\nh`Ă΁AubN̏̊JnƏIɂnh̃\bh (BlockBuilder#begin()  BlockBuilder#end()) ĂяoB</B>
	 * @param top CAEg邢̓ubÑCAEgw̎qm[h̃XgnB
	 * @param layout QƂ郌CAEgnB
	 * @param pageSet eLXgҏWʂݒ肷y[WEZbgnB
	 * @return eLXgҏWʂێy[WEZbgԂB
	 * @exception eLXgҏW̏Ɉُ킪ΗO (ReportException 邢 ReportUserException) 𓊂B
	 * ɁA`̃m[hQƂ郌CAEgɎw肳Ă ReportException 𓊂B
	 */
	private PageSet parse(List<Node> top, Layout layout, PageSet pageSet)
												throws ReportException {
		if (top != null) {
			Iterator<Node>	nodeIter = null;

			for (nodeIter = top.iterator(); nodeIter.hasNext(); ) {
				Node node = nodeIter.next();
				if (node instanceof Block) {
					BlockBuilder	builder = null;
					Context			context = null;
					int				i, iterCnt =  getBlockIterationCnt();
					push();
					/* we can invoke user's 'BlockBuilder#begin()'-methods
					 */
					if (((Block)node).getBuilder() != null) {
						context	= (new Context(node, getDataDictionary()));
						context.setIterationCnt(iterCnt);
						(builder = ((Block)node).getBuilder())
													.begin(node, context);
					}
					for (i = 0; i < iterCnt; ++i) {
						if (builder != null) {
							context.setIterationIndex(i);
							builder.enterIteration((Block)node, context);
						}
						parse(node.getChildren(), layout, pageSet);
					}
					/* we can invoke user's 'BlockBuilder#end()'-methods */
					if (builder != null) {
						context.setIterationIndex(i);
						builder.end(node, context);
					}
					pop();
					skipUntilBlockEnd();
				}
				else if (node instanceof PageFeedRecord) {
					feedPage(pageSet);
				}
				else if (node instanceof LineFeedRecord) {
					feedLine(pageSet);
				}
				else if (node instanceof Record) {
					updateDataDictionary();
					addLines(pageSet, createLines((Record)node, pageSet));
				}
				else {
					throw (new ReportException("unknown typed Node"
												+ "={" + node + "}"
												)
							);
				}
			}
		}
		return	pageSet;
	}

	/** CAEg (邢́Awb_/tb^ECAEg) QƂĕҏWf[^EZbgeLXgɕҏWB<BR>
	 * <B>pbP[WE[UCAEg\nh`Ăꍇɂ́ACAEg̊JnƏIɃnh̃\bh (Layout#begin()  Layout#end()) ĂяoB</B>
	 * @param layout CAEg (邢́Awb_/tb^ECAEg) nB
	 * @param transformer [g/wb_/tb^EgXtH[}nB
	 * @return eLXgҏWʂێy[WEZbgԂB
	 * @exception eLXgҏW̏Ɉُ킪ΗO (ReportException 邢 ReportUserException) 𓊂B
	 */
	private PageSet parseLayout(Layout	layout, Transformer	transformer)
												throws ReportException {
		Context	context = null;
		PageSet	pageSet = null;

		/* we can invoke user's `LayoutBuilder#begin()'-methods */
		if (layout.getBuilder() != null) {
			context	= (new Context(layout, getDataDictionary()));
			layout.getBuilder().begin(layout, context);
		}
		pageSet	= parse(layout.getChildren()
						, layout
						, (new PageSet(transformer))
						);
		/* we can invoke user's `LayoutBuilder#end()'-methods */
		if (context != null) { layout.getBuilder().end(layout, context); }
		return	pageSet;
	}

	/** wb_/tb^ECAEgQƂăwb_/tb^̕ҏWʂ߂B
	 * @param subPageSetLayout wb_/tb^ECAEgnB
	 * @param page wb_/tb^ǉy[WnB
	 * @exception wb_/tb^̕ҏWňُ킪ΗO (ReportException 邢 ReportUserException) 𓊂B
	 */
	private void parseSubPageSet(HeaderLayout	subPageSetLayout
								, Page			page
								) throws ReportException {
		Transformer	subTransformer = (new Transformer(subPageSetLayout
													, this
													)
										);
		page.getLines().addAll(((subPageSetLayout instanceof FooterLayout)
							?	page.getLines().size()
							:	0
							)
						, (subTransformer.parseLayout(subPageSetLayout
													, subTransformer
													)
							).getHeaderLines(subPageSetLayout)
						);
		return;
	}

	/** eLXgҏWʂێy[WɁAKvł΃wb_/tb^̕ҏWʂāAeLXgҏWʃy[Wm肷B
	 * @param page ҏWʂm肷y[WnB
	 * @exception y[W̃eLXgҏWʂ̊m蒆Ɉُ킪ΗO (ReportException 邢 ReportUseException) 𓊂B
	 */
	private void fixPage(Page	page) throws ReportException {
		page.fillBlankLines(getMaxCntLines());
		if (rootLayout.getHeaderLayout() != null) {
			parseSubPageSet(rootLayout.getHeaderLayout(), page);
		}
		if (rootLayout.getFooterLayout() != null) {
			parseSubPageSet(rootLayout.getFooterLayout(), page);
		}
		return;
	}

	/** eLXgҏWʂێy[WEZbĝׂẴy[W̕ҏWʂm肷B
	 * @param pageSet eLXgҏWʂێy[WEZbgnB
	 * @return eLXgҏWʂm肵y[WEZbgԂB
	 * @exception eLXgҏWʂ̊m蒆Ɉُ킪ΗO (ReportException 邢 ReportUserException) 𓊂B
	 */
	private PageSet fixPages(PageSet	pageSet) throws ReportException {
		int	pageNo = 1;
		setTotalPageNums(pageSet.getTotalPageNums());
		for (Page page : pageSet.getPages()) {
			if (page.getLines().size() == 0) {	break;	}
			setCurrentPageNum(pageNo);
			fixPage(page);
			++pageNo;
		}
		return	pageSet;
	}

	/** eLXgҏWʂ̃y[WEZbg̓em肵āAׂẴy[W̍s̓eeLXg߂B
	 * @param pageSet eLXgҏWʂێy[WEZbgnB
	 * @return eLXgҏWʂeLXgԂB
	 * @exception eLXgҏWʂ̌ňُ킪O (ReportException 邢 ReportUserException) 𓊂B
	 */
	private String flatten(PageSet	pageSet) {
		StringBuffer	result = (new StringBuffer(Keyword.EMPTY_VALUE));
		int				cntPages = 0, i;

		for (i = 0, cntPages = pageSet.getPages().size(); i < cntPages; ++i)
		{	Page	page = pageSet.getPages().get(i);
			int		cntLines = 0;

			if ((cntLines = page.getLines().size()) == 0) {	break;	}
			for (int j = 0; j < cntLines; ++j) {
				if ((i > 0) || j > 0) {
					result.append(rootLayout.getNewLineCode());
				}
				result.append(page.getLines().get(j).getValue());
			}
		}
		return	result.toString();
	}

	/** CAEgQƂāAҏWf[^EZbgҏWʂ̃eLXg߂B
	 * @param dataSet ҏWf[^EZbgnB
	 * @return ҏWʂ̃eLXgԂB
	 * @exception eLXg̕ҏWɈُ킪ΗO (ReportException 邢 ReportUserException) 𓊂B
	 */
	public String transform(DataSet	dataSet) throws ReportException {
		initDataSetReader(dataSet);
		initDataDict();
		setCurrentPageNum(1);
		return	flatten(fixPages(parseLayout(rootLayout, this)));
	}
}


/** eLXgҏWʂێy[WEZbg */
class PageSet {
	/** y[WEZbgێĂgXtH[} */
	private Transformer	transformer = null;

	/** eLXgҏWʂێy[W̃Xg */
	private List<Page>	pages = (new ArrayList<Page>());
	/** eLXgҏWʂێy[W̃Xg̃Qb^B
	 * @return eLXgҏWʂێy[W̃XgԂB
	 */
	List<Page> getPages() {	return	this.pages;	}
	/** eLXgҏWʂێ邠炽ȃy[Wy[W̃XgɒǉB
	 * ǉɌ݂̃y[WԍXVB
	 */
	private void addNewPage() {
		pages.add(new Page());
		transformer.getRootTransformer().incremantCurrentPageNum();
	}

	/** gXtH[}w肵ăy[WEZbg𐶐RXgN^B
	 * @param transformer y[WEZbgێgXtH[}nB
	 */
	PageSet(Transformer	transformer) {
		this.transformer	= transformer;
		pages.add(new Page());
	}

	/** Ō̃y[W߂B
	 * @return y[W̃Xg̍Ō̃y[WԂB
	 */
	private Page getLast() {
		int	n = pages.size();
		return	((n > 0)?	pages.get(n - 1): pages.get(0));
	}

	/** y[W߂B
	 * @return y[W̃Xg󂩂邢͍ŏ̃y[WҏWʂЂƂێĂȂ΃[AłȂ΃y[WԂB
	 */
	int getTotalPageNums() {
		int	n = pages.size();
		return	((n <= 0)?										0
				: (pages.get(n - 1).getLines().size() != 0)?	n
				:												(n - 1)
				);
	}

	/** Ō̃y[WɒǉĂs߂B
	 * @return	Ō̃y[WɒǉĂsԂB
	 */
	int getCntOfLines() {	return	getLast().getCntOfLines();	}

	/** y[W䂪Kvۂ𔻒肷B
	 * @param maxCntLines ősnB
	 * @return y[W䂪Kvł true AłȂ false ԂB
	 */
	private boolean needPageControl(int	maxCntLines) {
		return	(((maxCntLines != Layout.WITHOUT_PAGE_CONTROL)
				&& (transformer.getRootLayout() instanceof HeaderLayout)
																!= true)
				?	true
				:	false
				);
	}

	/** Ō̃y[Wɉss (TuE[`)B
	 * @param maxCntLines ősnB
	 * @return Ō̃y[Wɉss (Ō̃y[WɂȂĂ) y[WEZbgԂB
	 */
	private PageSet feedPage(int	maxCntLines) {
		if (needPageControl(maxCntLines) == true) {
			getLast().fillBlankLines(maxCntLines);
			addNewPage();
		}
		return	this;
	}
	/** Ō̃y[WɉssB
	 * @return Ō̃y[Wɉss (Ō̃y[WɂȂĂ) y[WEZbgԂB
	 */
	PageSet feedPage() {
		return	feedPage(transformer.getMaxCntLines());
	}

	/** Ō̃y[WɋsǉB
	 * @return sǉy[WEZbgԂB
	 */
	PageSet feedLine() {
		int	maxCntLines = transformer.getMaxCntLines();
		if ((needPageControl(maxCntLines) == true)
		&& maxCntLines == getLast().getLines().size())
		{	addNewPage();	}
		getLast().addBlankLine();
		return	this;
	}

	/** Ō̃y[WɕҏWς݂̍s̃XgǉB<BR>
	 * y[W䂪Kvł΁Aǉsێ̂ɕKvȂ炽ȃy[WǉB
	 * @param lines ǉҏWς݂̍s̃XgnB
	 * @return ҏWς݂̍s̃Xgǉy[WEZbgԂB
	 */
	PageSet addLines(List<Line>	lines) {
		int	cntLeftLines = lines.size();
		int	maxCntLines = transformer.getMaxCntLines(), limit, i;
		if (needPageControl(maxCntLines) == true) {
			Iterator<Line>	iter = lines.iterator();
			while (cntLeftLines > 0) {
				if ((limit = maxCntLines - getLast().getLines().size())
															> cntLeftLines)
				{	limit	= cntLeftLines;	}
				for (i = 0; i < limit; ++i) {
					getLast().addLine(iter.next()); --cntLeftLines;
				}
				if (cntLeftLines > 0) {	addNewPage();	}
			}
		}
		else {
			for (i = 0; i < cntLeftLines; ++i) {
				getLast().addLine(lines.get(i));
			}
		}
		return	this;
	}

	/** wb_/tb^̕ҏWʂێy[WEZbgwb_/tb^̍s̃Xg߂B
	 * @param headerLayout wb_/tb^ECAEgnB
	 * @return  wb_/tb^ECAEgŎw肳Ăwb_/tb^̍s̍sXgԂB
	 */
	List<Line> getHeaderLines(HeaderLayout	headerLayout) {
		List<Line>	lines = pages.get(0).getLines();
		int			size, limit, i;
		if (headerLayout.getLines() > (size = lines.size())) {
			for (limit = headerLayout.getLines()  - size, i = 0
			; i < limit
			; ++i
			) {
				lines.add(new Line((new StringBuffer(Keyword.EMPTY_VALUE))
									, 0
									)
						);
			}
		}
		return	(pages.get(0).getLines()
								.subList(0, headerLayout.getLines())
								);
	}
}


/** ҏWʂێy[W */
class Page {
	/** ҏWʂ̍s̃Xg */
	private List<Line>	lines = (new ArrayList<Line>());
	/** ҏWʂ̍s̃Xg̃Qb^B
	 * @return ҏWʂ̍s̃XgԂB
	 */
	List<Line> getLines() {	return	this.lines;	}
	/** y[WɒǉĂs߂B
	 * @return	y[WɒǉĂsԂB
	 */
	int getCntOfLines() {	return	lines.size();	}


	/** ҏWʂێy[W̃RXgN^ */
	Page() {	;	}

	/** ҏWʂ̍sXgɒǉB
	 * @param line ǉҏWʂ̍snB
	 */
	void addLine(Line	line) {
		lines.add(line);
	}

	/** sXgɒǉB */
	void addBlankLine() {
		addLine(new Line((new StringBuffer(Keyword.EMPTY_VALUE)), 0));
	}

	/** y[WsŖB
	 * @param maxCntLines y[W̍ősnB
	 */
	void fillBlankLines(int	maxCntLines) {
		int	fillLines = maxCntLines - lines.size(), i;
		for (i = 0; i < fillLines; ++i) {	addBlankLine();	}
	}
}


/** ҏWς݂̃tB[h̓e */
class FormattedField {
	/** CAEg̃tB[hw */
	private Field		field	= null;
	/** CAEg̃tB[hw̃Qb^B */
	Field getField() {	return	this.field;	}
	/** ҏWʂ̍s̃Xg */
	private List<Line>	values = (new ArrayList<Line>());
	/** ҏWʂ̍s̃Xg̃Qb^B */
	List<Line> getValues() {	return	this.values;	}

	/** CAEg̃tB[hwŕҏWς݂̃tB[h𐶐RXgN^B
	 * @param field CAEg̃tB[hwnB
	 */
	FormattedField(Field	field) { this.field	= field;	}

	/** ҏWʂ̍sł邩ۂ𔻒肷B
	 * @return ҏWʂ̍s̃Xgł true AłȂ false ԂB
	 */
	boolean isEmpty() {	return	((values.size() == 0)?	true: false);	}

	/** ҏWʂ̓es̃XgɒǉB
	 * @param codes ҏWʂ̓e\̔z (char[]) nB
	 * @param start ҏWeǉ镶z̊JnCfbNX ([ȏ) nB
	 * @param end ҏWʂǉ镶nB
	 * @param digits ҏWʂǉ镶z̕ (ł͂Ȃ) nB
	 */
	private void addValue(char	codes[]
						, int	start
						, int	end
						, int	digits
						) {
		StringBuffer	sb = (new StringBuffer(Keyword.EMPTY_VALUE));
		if (start < end) {	sb.append(codes, start, (end - start));	}
		values.add(new Line(sb, digits));
	}

	/** {w̕ҏWʕ̐܂ԂsB
	 * @param value ܂ԂsҏWʕnB
	 * @param field ҏWʂɑΉ郌CAEg̃tB[hwnB
	 * @exception ܂Ԃňُ킪N ReportException 𓊂B
	 * ɁAtB[h̕ 1 łƂɓ{SpҏWf[^Ɏw肳Ă ReportException 𓊂B
	 */
	private void foldJP(String	value, Field	field)
											throws ReportException {
		char[]	codes = value.toCharArray();
		int		digits = 0, start = 0, end = 0;

		for (int i = 0; i < codes.length; ++i) {
			if ((codes[i] == Keyword.MAC_NEW_LINE_CODE)
			|| codes[i] == Keyword.UNIX_NEW_LINE_CODE)
			{
				addValue(codes, start, end, digits);
				if (((codes[i] == Keyword.MAC_NEW_LINE_CODE)
				&& i < (codes.length - 1))
				&& codes[i + 1] == Keyword.UNIX_NEW_LINE_CODE)
				{	++i;	}
				start = end = i + 1; digits = 0;
			}
			else if (Keyword.isSingleWidthCodeJP(codes[i]) == true) {
				if (Keyword.isWhiteSpace(codes[i]) == true) {
					codes[i]	= Keyword.WHITE_SPACE;
				}
				++end; ++digits;
			}
			else if (field.getWidth() < 2) {
				throw (new ReportException("this filed cannot accept"
										+ " wide character"
										+ "=[" + codes[i] + "]"
										+ ", field={" + field + "}"
										)
						);
			}
			else if (field.getWidth() < (digits + 2)) {
				addValue(codes, start, end, digits);
				start = end = i; digits = 0;
				--i;
			}
			else {	++end; digits += 2;	}
			if (field.getWidth() == digits) {
				addValue(codes, start, end, digits);
				start = end; digits = 0;
			}
		}
		if (start < end) {	addValue(codes, start, end, digits);	}
		return;
	}

	/** tB[h̕ҏWsB<BR>
	 * Œ蕶tB[hł΃CAEgŎw肳ꂽŒ蕶tH[}bgB<BR>
	 * ҏWtB[hł΁AgXtH[}ێҏWf[^̎\QƂĒu߁AtH[}bgB<BR>
	 * pbP[WE[U`tH[}b^ (FieldFormat) w肳Ă΂𗘗p (FieldFormat#format()) tH[}bgsB<BR>
	 * Kvł΁A{w̐܂ԂsāAҏWʂsɕB<BR>
	 * <B>pbP[WE[U`\bh FieldFormat#format() ́Ã\bhĂяoB</B>
	 * @param transformer \QƂgXtH[}nB
	 * @return ҏWς݃tB[hԂB
	 * @exception tB[hҏWňُ킪NΗO (ReportException 邢 ReportUserException) 𓊂B
	 */
	FormattedField format(Transformer transformer, int	indexOfTarget)
												throws ReportException {
		FieldFormatResult	userFormatResult = null;
		DataDictionary		dataDict = transformer.getDataDictionary();
		FieldFormat			userFormatter = null;
		Context				context = null;
		String				value = null;

		if (field.getType() == FieldType.Literal) {
			value	= field.getValue();
		}
		else if ((value = dataDict.lookUp(field.getValue())) == null)
		{	value	= Keyword.EMPTY_VALUE;	}
		else if (field.getValue().equals(Keyword.CURRENT_PAGE_NUM)
															== true) {
			StringBuffer	buf = (new StringBuffer(""));
			int				len = value.length()
							, width = field.getWidth()
							, left, i
							;
			for (i = 0, left = width - len; i < left; ++i) {
				buf.append(Keyword.WHITE_SPACE);
			}
			value	= buf.append(value).toString();
		}
		else { ; /* value had been set */	}

		/* we can invoke user's `FieldFormat#format()'-method */
		if ((userFormatter = field.getUserFormatter()) != null) {
			context					= (new Context(field, dataDict));
			context.setIndexOfTarget(indexOfTarget);
			userFormatResult		= userFormatter.format(value
															, field
															, context
															);
			if ((userFormatResult != null)
			&& (value = userFormatResult.getValue()) == null)
			{	value	= Keyword.EMPTY_VALUE;	}
		}
		if ((userFormatResult == null)
		|| userFormatResult.getNeedFoldJP() == true)
		{	foldJP(value, field);	}
		return	this;
	}
}
